#--------------
#Tick Functions
#--------------


#---------------------
#Custom Mob Generation
#---------------------



#Crabs

execute as @e[type=zombified_piglin,tag=crab] run function fishing:mobs/beach_crab/main

execute as @e[type=bat,tag=crabspawn] at @s run function fishing:mobs/beach_crab/spawnegg

execute as @a[scores={crablegdelay=1..},nbt=!{SelectedItem:{id:"minecraft:cooked_chicken",tag:{crableg:1b}}}] run scoreboard players remove @s crablegdelay 1

execute as @a[nbt={SelectedItem:{id:"minecraft:cooked_cod",tag:{grilledcrableg:1b}}}] run scoreboard players set @s crablegdelay 2
execute as @a[scores={crablegdelay=1..,atefish=1..}] at @s run function fishing:items/crablegeat

execute as @a[scores={crabbisquedelay=1..},nbt=!{SelectedItem:{id:"minecraft:rabbit_stew",tag:{crabbisque:1b}}}] run scoreboard players remove @s crabbisquedelay 1

execute as @a[nbt={SelectedItem:{id:"minecraft:rabbit_stew",tag:{crabbisque:1b}}}] run scoreboard players set @s crabbisquedelay 2
execute as @a[scores={crabbisquedelay=1..,atestew=1..}] at @s run function fishing:items/crabbisqueeat

execute as @a[scores={minnowdelay=1..},nbt=!{SelectedItem:{id:"minecraft:dried_kelp",tag:{grillminnow:1b}}}] run scoreboard players remove @s minnowdelay 1

execute as @a[nbt={SelectedItem:{id:"minecraft:dried_kelp",tag:{grillminnow:1b}}}] run scoreboard players set @s minnowdelay 2
execute as @a[scores={minnowdelay=1..,atekelp=1..}] at @s run function fishing:items/minnoweat

#Minnow

execute as @e[type=item_display,tag=minnowmodel] at @s rotated as @e[tag=minnow,limit=1,distance=..1,sort=nearest] run tp @s ~ ~ ~ ~ ~

execute as @e[type=cod,tag=minnow] at @s run function fishing:mobs/minnow/main

execute as @e[type=item_display,tag=minnowmodel] at @s rotated as @e[tag=minnow,limit=1,distance=..1,sort=nearest] run tp @s ~ ~ ~ ~ ~

execute as @e[type=item_display,tag=minnowmodel] at @s unless entity @e[type=cod,tag=minnow,distance=..1] run function fishing:mobs/minnow/modeldelete

execute as @e[type=bat,tag=minnowspawn] at @s run function fishing:mobs/minnow/spawnegg

#Bass

execute as @e[type=item_display,tag=bassmodel] at @s rotated as @e[tag=bass,limit=1,distance=..1,sort=nearest] run tp @s ~ ~ ~ ~ ~

execute as @e[type=salmon,tag=bass] at @s run function fishing:mobs/bass/main

execute as @e[type=item_display,tag=bassmodel] at @s rotated as @e[type=salmon,tag=bass,limit=1,distance=..1,sort=nearest] run tp @s ~ ~ ~ ~ ~

execute as @e[type=item_display,tag=bassmodel] at @s unless entity @e[type=salmon,tag=bass,distance=..1] run function fishing:mobs/bass/modeldelete

execute as @e[type=bat,tag=bassspawn] at @s run function fishing:mobs/bass/spawnegg


execute as @a[scores={bassdelay=1..},nbt=!{SelectedItem:{id:"minecraft:cooked_cod",tag:{grillbass:1b}}}] run scoreboard players remove @s bassdelay 1

execute as @a[nbt={SelectedItem:{id:"minecraft:cooked_cod",tag:{grillbass:1b}}}] run scoreboard players set @s bassdelay 2
execute as @a[scores={bassdelay=1..,atefish=1..}] at @s run function fishing:items/basseat

#Jellyfish

execute as @e[type=item_display,tag=jellymodel] at @s rotated as @e[tag=jelly,limit=1,distance=..1,sort=nearest] run tp @s ~ ~ ~ ~ ~

execute as @e[type=pufferfish,tag=jelly] at @s run function fishing:mobs/jellyfish/main

execute as @e[type=item_display,tag=jellymodel] at @s rotated as @e[tag=bass,limit=1,distance=..1,sort=nearest] run tp @s ~ ~ ~ ~ ~

execute as @e[type=item_display,tag=jellymodel] at @s unless entity @e[type=pufferfish,tag=jelly,distance=..1] run function fishing:mobs/jellyfish/modeldelete

execute as @e[type=bat,tag=jellyspawn] at @s run function fishing:mobs/jellyfish/spawnegg

execute as @e[type=pufferfish,tag=jelly,nbt=!{PuffState:2}] run data merge entity @s {PuffState:2}


execute as @a[scores={leechdelay=1..},nbt=!{SelectedItem:{id:"minecraft:pufferfish",tag:{leech:1b}}}] run scoreboard players remove @s leechdelay 1

execute as @a[nbt={SelectedItem:{id:"minecraft:dried_kelp",tag:{leech:1b}}}] run scoreboard players set @s leechdelay 2
execute as @a[scores={leechdelay=1..,atekelp=1..}] at @s run function fishing:items/leecheat

#Catfish

execute as @e[type=item_display,tag=catmodel] at @s rotated as @e[tag=cat,limit=1,distance=..1,sort=nearest] run tp @s ~ ~ ~ ~ ~

execute as @e[type=salmon,tag=cat] at @s run function fishing:mobs/catfish/main

execute as @e[type=item_display,tag=catmodel] at @s rotated as @e[type=salmon,tag=cat,limit=1,distance=..1,sort=nearest] run tp @s ~ ~ ~ ~ ~

execute as @e[type=item_display,tag=catmodel] at @s unless entity @e[type=salmon,tag=cat,distance=..1] run function fishing:mobs/catfish/modeldelete

execute as @e[type=bat,tag=catspawn] at @s run function fishing:mobs/catfish/spawnegg

execute as @a[scores={catdelay=1..},nbt=!{SelectedItem:{id:"minecraft:cooked_porkchop",tag:{grilledcatfish:1b}}}] run scoreboard players remove @s catdelay 1

execute as @a[nbt={SelectedItem:{id:"minecraft:cooked_porkchop",tag:{grilledcatfish:1b}}}] run scoreboard players set @s catdelay 2
execute as @a[scores={catdelay=1..,atepork=1..}] at @s run function fishing:items/catfisheat

#Sunfish

execute as @e[type=item_display,tag=sunfishmodel] at @s rotated as @e[tag=sunfish,limit=1,distance=..1,sort=nearest] run tp @s ~ ~ ~ ~ ~

execute as @e[type=salmon,tag=sunfish] at @s run function fishing:mobs/sunfish/main

execute as @e[type=item_display,tag=sunfishmodel] at @s rotated as @e[type=salmon,tag=sunfish,limit=1,distance=..1,sort=nearest] run tp @s ~ ~ ~ ~ ~

execute as @e[type=item_display,tag=sunfishmodel] at @s unless entity @e[type=salmon,tag=sunfish,distance=..1] run function fishing:mobs/sunfish/modeldelete

execute as @e[type=bat,tag=sunfishspawn] at @s run function fishing:mobs/sunfish/spawnegg


#Pike

execute as @e[type=item_display,tag=pikemodel] at @s rotated as @e[tag=pike,limit=1,distance=..1,sort=nearest] run tp @s ~ ~ ~ ~ ~

execute as @e[type=salmon,tag=pike] at @s run function fishing:mobs/pike/main

execute as @e[type=item_display,tag=pikemodel] at @s rotated as @e[type=salmon,tag=pike,limit=1,distance=..1,sort=nearest] run tp @s ~ ~ ~ ~ ~

execute as @e[type=item_display,tag=pikemodel] at @s unless entity @e[type=salmon,tag=pike,distance=..1] run function fishing:mobs/pike/modeldelete

execute as @e[type=bat,tag=pikespawn] at @s run function fishing:mobs/pike/spawnegg

#Lionfish

execute as @e[type=item_display,tag=lionmodel] at @s rotated as @e[tag=lion,limit=1,distance=..1,sort=nearest] run tp @s ~ ~ ~ ~ ~

execute as @e[type=pufferfish,tag=lion] at @s run function fishing:mobs/lionfish/main

execute as @e[type=item_display,tag=lionmodel] at @s rotated as @e[tag=bass,limit=1,distance=..1,sort=nearest] run tp @s ~ ~ ~ ~ ~

execute as @e[type=item_display,tag=lionmodel] at @s unless entity @e[type=pufferfish,tag=lion,distance=..1] run function fishing:mobs/lionfish/modeldelete

execute as @e[type=bat,tag=lionspawn] at @s run function fishing:mobs/lionfish/spawnegg

execute as @e[type=pufferfish,tag=lion,nbt=!{PuffState:2}] run data merge entity @s {PuffState:2}

execute as @a[scores={liondelay=1..},nbt=!{SelectedItem:{id:"minecraft:cooked_porkchop",tag:{grilllion:1b}}}] run scoreboard players remove @s liondelay 1

execute as @a[nbt={SelectedItem:{id:"minecraft:cooked_porkchop",tag:{grilllion:1b}}}] run scoreboard players set @s liondelay 2
execute as @a[scores={liondelay=1..,atepork=1..}] at @s run function fishing:items/lionfisheat

#Perch

execute as @e[type=item_display,tag=perchmodel] at @s rotated as @e[tag=perch,limit=1,distance=..1,sort=nearest] run tp @s ~ ~ ~ ~ ~

execute as @e[type=salmon,tag=perch] at @s run function fishing:mobs/perch/main

execute as @e[type=item_display,tag=perchmodel] at @s rotated as @e[type=salmon,tag=perch,limit=1,distance=..1,sort=nearest] run tp @s ~ ~ ~ ~ ~

execute as @e[type=item_display,tag=perchmodel] at @s unless entity @e[type=salmon,tag=perch,distance=..1] run function fishing:mobs/perch/modeldelete

execute as @e[type=bat,tag=perchspawn] at @s run function fishing:mobs/perch/spawnegg

#Spawn Egg 

execute as @e[type=bat,tag=seahorsespawn] at @s run function fishing:mobs/seahorse/spawnegg

execute as @e[type=item_display,tag=seahorsemodelred] at @s rotated as @e[tag=seahorse,limit=1,distance=..1,sort=nearest] run tp @s ~ ~ ~ ~ ~
execute as @e[type=item_display,tag=seahorsemodelblue] at @s rotated as @e[tag=seahorse,limit=1,distance=..1,sort=nearest] run tp @s ~ ~ ~ ~ ~

execute as @e[type=cod,tag=seahorse,nbt={HurtTime:10s}] as @e[limit=1,sort=nearest,type=item_display,tag=seahorsemodelblue] at @s run function fishing:mobs/seahorse/horsehurt
execute as @e[type=cod,tag=seahorse,nbt={HurtTime:10s}] as @e[limit=1,sort=nearest,type=item_display,tag=seahorsemodelred] at @s run function fishing:mobs/seahorse/horsehurt

execute as @e[type=cod,tag=seahorse,nbt={HurtTime:1s}] as @e[limit=1,sort=nearest,type=item_display,tag=seahorsemodelblue] run data merge entity @s {item:{id:"minecraft:purple_dye",Count:1b,tag:{CustomModelData:111}},item_display:"fixed"}
execute as @e[type=cod,tag=seahorse,nbt={HurtTime:1s}] as @e[limit=1,sort=nearest,type=item_display,tag=seahorsemodelred] run data merge entity @s {item:{id:"minecraft:purple_dye",Count:1b,tag:{CustomModelData:108}},item_display:"fixed"}

execute as @e[type=item_display,tag=seahorsemodelred] at @s unless entity @e[type=cod,tag=seahorse,distance=..1] run function fishing:mobs/seahorse/modeldelete
execute as @e[type=item_display,tag=seahorsemodelblue] at @s unless entity @e[type=cod,tag=seahorse,distance=..1] run function fishing:mobs/seahorse/modeldelete

#-------------------
#Jukebox Custom Disc
#-------------------

execute as @a[scores={rightclick=1..},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{labsdisc:1b}}}] at @s run function fishing:items/music_disc_labs/startraycast
execute as @e[type=armor_stand,tag=disccheck] at @s unless block ~ ~ ~ jukebox[has_record=true]{RecordItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{CustomModelData:142,labsdisc:1b,display:{Name:'[{"text":"Music Disc","italic":false,"color":"aqua"}]',Lore:['[{"text":"DestroLynx - Ocean Labs","italic":false,"color":"gray"},{"text":"","italic":false,"color":"dark_purple"}]','[{"text":"","italic":false,"color":"dark_purple"}]','[{"text":"Oceanic","italic":false,"color":"blue"}]']}}}} run function fishing:items/music_disc_labs/out

execute as @a[scores={rightclick=1..},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{falldisc:1b}}}] at @s run function fishing:items/music_disc_fall/startraycast
execute as @e[type=armor_stand,tag=disccheck1] at @s unless block ~ ~ ~ jukebox[has_record=true]{RecordItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{CustomModelData:147,falldisc:1b,display:{Name:'[{"text":"Music Disc","italic":false,"color":"aqua"}]',Lore:['[{"text":"DestroLynx - Falling Void","italic":false,"color":"gray"},{"text":"","italic":false,"color":"dark_purple"}]','[{"text":"","italic":false,"color":"dark_purple"}]','[{"text":"Oceanic","italic":false,"color":"blue"}]']}}}} run function fishing:items/music_disc_fall/out

execute as @a[scores={rightclick=1..},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{glacierdisc:1b}}}] at @s run function fishing:items/music_disc_glacier/startraycast
execute as @e[type=armor_stand,tag=disccheck2] at @s unless block ~ ~ ~ jukebox[has_record=true]{RecordItem:{id:"minecraft:carrot_on_a_stick",Count:1b,tag:{CustomModelData:153,glacierdisc:1b,display:{Name:'[{"text":"Music Disc","italic":false,"color":"aqua"}]',Lore:['[{"text":"DestroLynx - Glacier Caves","italic":false,"color":"gray"},{"text":"","italic":false,"color":"dark_purple"}]','[{"text":"","italic":false,"color":"dark_purple"}]','[{"text":"Oceanic","italic":false,"color":"blue"}]']}}}} run function fishing:items/music_disc_glacier/out

#-------------------
#Message In a Bottle
#-------------------

execute as @a[scores={rightclick=1..},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{messageinbottle:1b}}}] at @s run function fishing:items/messageinabottle

#Loot Bag

execute as @a[scores={rightclick=1..},nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick",tag:{lootbag:1b}}}] at @s run function fishing:items/lootbag


#------
#Blocks
#------

#--------
#End Tick
#--------

scoreboard players reset @a atefish
scoreboard players reset @a atestew