#-----------
#Runs every 20 ticks
#-----------

#----------
#New Player
#----------

execute as @a[tag=!fishingcertified] at @s run give @s written_book{pages:['{"text":"Hey there fisherman! \\n\\nIf your reading this. I imagine you must be the new guy. If not, dont worry! You dont need this book after youve read it\\n\\nunless you have a bad memory\\n "}','{"text":"Anyway! Welcome to Oceanic. the name people have come up with for this rather unnatural event.\\n\\nMuch new life has been blooming in the ocean, people have theorized endlessly about what might have happened. A portal to another world?"}','{"text":"Or a sudden and most unnatural evolution?\\n\\nI dont involve myself in all that drama though. We are simple fisherman after all!\\n\\nSo ill just give you a basic rundown of the world we are now living in. and how to best take advantage of its contents!"}','{"text":"The first thing you are going to want to do in your fishing journey is to craft a fish grill! All recipes are on the final page.\\n\\nOnce you do that, go crazy! Fishing in all different biome will lead you to catch all kinds of different fish"}','{"text":"Instead of the boring old cod and salmon of the old world. You can also craft sushi with pretty much any fish by tossing it on the ground along with a piece of kelp.\\n\\nThis drama has also stirred up some danger! Watch out for pirate ships on the high seas, i doubt they\'ll be friendly."}','{"text":"And if you do go out exploring on boat, people have built lighthouses to guide people like you to shore at night! You might wanna talk to the keeper of those lighthouses, they might sell something useful!"}','{"text":"Speaking of exploring on boat, these fish arent just something to catch with a rod! If you decide to do a bit of diving you can find diverse kinds of fish like bass, perch. And much more!"}','{"text":"Anyways, i dont wanna waste your time so ill keep this as short as i can. Here are all the Recipes you might need:"}','["",{"text":"Floor Crafting:","bold":true},{"text":"\\n\\n\\nCrab Bisque:\\n2x Grilled Crab Legs\\n1x Mushroom Stew\\n\\nGrilled Fish:\\n1x Any custom fish\\n1x Fish Grill\\n\\nSushi:\\n1x Any custom fish\\n1x Kelp","color":"reset"}]','["",{"text":"Crafting Table Recipes:","bold":true},{"text":"\\n\\n\\n","color":"reset"},{"text":"Fish Grill","hoverEvent":{"action":"show_text","contents":{"text":"\\ue000","font":"custom:fishing"}}},{"text":"\\n\\n"},{"text":"Trident","hoverEvent":{"action":"show_text","contents":{"text":"\\ue001","font":"custom:fishing"}}},{"text":"\\n\\nSorry about the tiny font, better examples are on the planetmc page"}]','["",{"text":"Tips:","bold":true},{"text":"\\n\\nCrumbled Cans are considered junk but can be used as iron nuggets\\n\\nFrog Legs can be used to brew potions of leaping","color":"reset"}]'],title:"Oceanic Guide",author:"Master Angler",display:{Lore:['[{"text":"Oceanic","italic":false,"color":"blue"}]']},CustomModelData:124}
execute as @a[tag=!fishingcertified] run tag @s add fishingcertified

#-----------------
#Entity Generation
#-----------------

execute as @e[type=turtle,tag=!entitychecked] at @s unless block ~ ~ ~ water if predicate fishing:coinflip run function fishing:mobs/beach_crab/crabspawn

execute as @e[type=turtle,tag=!entitychecked] at @s unless block ~ ~ ~ water if predicate fishing:coinflip run function fishing:mobs/angler/pick
execute as @e[type=turtle,tag=!entitychecked] at @s run tag @s add entitychecked

#--------------
#Floor Crafting
#--------------

execute as @e[type=item,nbt={Item:{id:"minecraft:command_block",Count:1b,tag:{fishgrill:1b}}}] at @s run function fishing:items/fish_grill/main

execute as @e[type=item,nbt={Item:{id:"minecraft:kelp",Count:1b}}] at @s run function fishing:items/sushimain


#Seahorse Model

execute as @e[type=tropical_fish,tag=!entitychecked] at @s if predicate fishing:lukewarm_ocean_check if predicate fishing:seahorsespawn run function fishing:mobs/seahorse/spawnseahorseblue

execute as @e[type=tropical_fish,tag=!entitychecked] at @s if predicate fishing:lukewarm_ocean_check if predicate fishing:seahorsespawn run function fishing:mobs/seahorse/spawnseahorsered

execute as @e[type=cod,tag=!entitychecked] at @s if predicate fishing:deep_oceancheck if predicate fishing:seahorsespawn run function fishing:mobs/seahorse/spawnseahorseblue

execute as @e[type=cod,tag=!entitychecked] at @s if predicate fishing:deep_oceancheck if predicate fishing:seahorsespawn run function fishing:mobs/seahorse/spawnseahorsered

execute as @e[type=tropical_fish,tag=!entitychecked] at @s if predicate fishing:warm_oceancheck if predicate fishing:seahorsespawn run function fishing:mobs/seahorse/spawnseahorseblue

execute as @e[type=tropical_fish,tag=!entitychecked] at @s if predicate fishing:warm_oceancheck if predicate fishing:seahorsespawn run function fishing:mobs/seahorse/spawnseahorsered


#Minnow

execute as @e[type=cod,tag=!entitychecked] at @s if predicate fishing:swampcheck if predicate fishing:coinflip run function fishing:mobs/minnow/spawn
execute as @e[type=salmon,tag=!entitychecked] at @s if predicate fishing:rivercheck if predicate fishing:coinflip run function fishing:mobs/minnow/spawn
execute as @e[type=cod,tag=!entitychecked] at @s if predicate fishing:cold_ocean_check if predicate fishing:coinflip run function fishing:mobs/minnow/spawn
execute as @e[type=cod,tag=!entitychecked] at @s if predicate fishing:deep_cold_oceancheck if predicate fishing:coinflip run function fishing:mobs/minnow/spawn


#Bass

execute as @e[type=cod,tag=!entitychecked] at @s if predicate fishing:swampcheck if predicate fishing:bassspawn run function fishing:mobs/bass/spawn
execute as @e[type=salmon,tag=!entitychecked] at @s if predicate fishing:rivercheck if predicate fishing:bassspawn run function fishing:mobs/bass/spawn
execute as @e[type=cod,tag=!entitychecked] at @s if predicate fishing:deep_oceancheck if predicate fishing:bassspawn run function fishing:mobs/bass/spawn
execute as @e[type=cod,tag=!entitychecked] at @s if predicate fishing:cold_ocean_check if predicate fishing:bassspawn run function fishing:mobs/bass/spawn
execute as @e[type=tropical_fish,tag=!entitychecked] at @s if predicate fishing:warm_oceancheck if predicate fishing:bassspawn run function fishing:mobs/bass/spawn
execute as @e[type=cod,tag=!entitychecked] at @s if predicate fishing:oceancheck if predicate fishing:bassspawn run function fishing:mobs/bass/spawn

#Jellyfish

execute as @e[type=tropical_fish,tag=!entitychecked] at @s if predicate fishing:seahorsespawn run function fishing:mobs/jellyfish/spawn

#Catfish

execute as @e[type=salmon,tag=!entitychecked] at @s if predicate fishing:rivercheck if predicate fishing:bassspawn run function fishing:mobs/catfish/spawn

#Sunfish

execute as @e[type=tropical_fish,tag=!entitychecked] at @s if predicate fishing:seahorsespawn run function fishing:mobs/sunfish/spawn

#Pikes

execute as @e[type=cod,tag=!entitychecked] at @s if predicate fishing:cold_ocean_check if predicate fishing:seahorsespawn run function fishing:mobs/pike/spawn
execute as @e[type=cod,tag=!entitychecked] at @s if predicate fishing:deep_cold_oceancheck if predicate fishing:seahorsespawn run function fishing:mobs/pike/spawn
execute as @e[type=cod,tag=!entitychecked] at @s if predicate fishing:oceancheck if predicate fishing:seahorsespawn run function fishing:mobs/pike/spawn

#Lionfish

execute as @e[type=tropical_fish,tag=!entitychecked] at @s if predicate fishing:lionfishspawn run function fishing:mobs/lionfish/spawn

#Perch

execute as @e[type=cod,tag=!entitychecked] at @s if predicate fishing:oceancheck if predicate fishing:bassspawn run function fishing:mobs/perch/spawn
execute as @e[type=salmon,tag=!entitychecked] at @s if predicate fishing:rivercheck if predicate fishing:bassspawn run function fishing:mobs/perch/spawn


#Beach Grass

execute as @e[type=item_display,tag=beachgrass,tag=!placed] at @s if block ~ ~ ~ air run function fishing:blocks/beach_grass/place

#End Tick
execute as @e[type=tropical_fish,tag=!entitychecked] at @s run tag @s add entitychecked
execute as @e[type=salmon,tag=!entitychecked] at @s run tag @s add entitychecked
execute as @e[type=cod,tag=!entitychecked] at @s run tag @s add entitychecked
schedule function fishing:tick_20t 20t append